const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of manufacturers by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} manufacturers - The array of manufacturers to format.
 * @returns {Promise<Object[]>} - The formatted array of manufacturers.
 */
const formatWithModifier = async (manufacturers) => {
    return Promise.all(
        manufacturers.map(async (manufacturer) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: manufacturer.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...manufacturer,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all manufacturers with their parent manufacturer title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.manufacturersId - The ids of the manufacturers to retrieve.
 * @returns {Promise<Object>} - The response object with the manufacturers and success status.
 */
async function getAll(params) {
    try {
        // filters
        const filterConditions = {};

        let manufacturers = []
        manufacturers = await dbSAPPS.Manufacturer.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
        });

        manufacturers = manufacturers.map(manufacturer => {
            return {
                ...manufacturer.dataValues
            }
        });

        manufacturers = await formatWithModifier(manufacturers);

        return {
            manufacturers,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get manufacturer items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the manufacturer items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the manufacturer items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the manufacturer items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        let options = [];
        options = await dbSAPPS.Manufacturer.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']]
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active manufacturer items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.Manufacturer.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new manufacturer item.
 * 
 * @param {Object} params - The new manufacturer item data.
 * @param {string} params.name - The name of the manufacturer item.
 * @param {string} params.title - The title of the manufacturer item.
 * @param {number} [params.parent_id] - The ID of the parent manufacturer item.
 * @param {string} [params.url] - The URL of the manufacturer item.
 * @param {string} [params.icon] - The icon of the manufacturer item.
 * @param {string} [params.type=link] - The type of the manufacturer item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the manufacturer item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the manufacturer item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the manufacturer item.
 * @param {number} [params.owner=1] - The ID of the user who created the manufacturer item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the manufacturer item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the manufacturer item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.Manufacturer.findOne({
            where: { display_name: params.display_name },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.Manufacturer.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing manufacturer item.
 * 
 * @param {number} id - The ID of the manufacturer item to update.
 * @param {Object} params - The updated manufacturer item data.
 * @param {string} [params.name] - The new name of the manufacturer item.
 * @param {string} [params.title] - The new title of the manufacturer item.
 * @param {number} [params.parent_id] - The new parent ID of the manufacturer item.
 * @param {string} [params.url] - The new URL of the manufacturer item.
 * @param {string} [params.icon] - The new icon of the manufacturer item.
 * @param {string} [params.type] - The new type of the manufacturer item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the manufacturer item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the manufacturer item.
 * @param {number} [params.modified] - The new last modification timestamp of the manufacturer item.
 * @param {number} [params.owner] - The new ID of the user who created the manufacturer item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the manufacturer item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the manufacturer item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const manufacturer = await dbSAPPS.Manufacturer.findByPk(id);
        if (!manufacturer) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.Manufacturer.findOne({
            where: {
                display_name: params.display_name,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await manufacturer.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a manufacturer
 * @param {number} id - the id of the manufacturer
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const manufacturer = await dbSAPPS.Manufacturer.findByPk(id);
        if (!manufacturer) return { success: false, message: 'ID not found!' };

        // delete
        await manufacturer.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
